unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Edit3: TEdit;
    Label3: TLabel;
    Button1: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Button2: TButton;
    Label6: TLabel;
    Edit6: TEdit;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Panel4: TPanel;
    Label2: TLabel;
    LabeledEdit7: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    Button5: TButton;
    LabeledEdit9: TLabeledEdit;
    Button7: TButton;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure LabeledEdit7Change(Sender: TObject);
    procedure LabeledEdit9Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure InitialSettings;
    procedure MakeProbs;
    procedure MakeProbGraph;
    procedure MakeIntervGraph;
    function StringToFloat(Str : string) : double;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  const                         {tbv graphics}
  PosX1=70;
  PosX2=PosX1+360;
  PosY1=70;
  PosY2=PosY1+190;

var
  Form1: TForm1;
  DF   : integer;
  Ttest, Probab : real;
  LowerPoint, UpperPoint : real;
  LowerLimit, UpperLimit :real;
  Probability, Fvalue, Density : array [1..1000] of real;
  CalcProb, Interval, Negative : boolean;
  InitDecSep : char;

implementation

uses Unit2, Unit4, Unit5;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  DF:=10;
  InitialSettings;
  InitDecSep:=DecimalSeparator
end;


procedure Tform1.InitialSettings;
begin
  Edit1.Text:='10';
  Edit3.Text:='1.81';
  Edit4.Text:='95';
  Edit5.Text:='95';
  Edit6.Text:='1.81';
  LabeledEdit7.Text:='-1.81';
  LabeledEdit9.Text:='1.81';
  LabeledEdit8.Text:='90';
  Button3.Enabled:=true;
  Button4.Enabled:=true;
  Button7.Enabled:=true;
end;


procedure TForm1.Edit1Click(Sender: TObject);
begin
  Form4.Visible:=false;
  Form5.Visible:=false;
end;


procedure TForm1.Edit1Change(Sender: TObject);
begin
  Edit4.Text:='';
  Edit6.Text:='';
  LabeledEdit8.Text:='';
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button7.Enabled:=false;
end;


procedure TForm1.Edit1Exit(Sender: TObject);
begin
  DF:=round(stringtofloat(Edit1.text));
  Edit1.Text:=inttostr(DF);
  if DF<=0 then
  begin
    Edit1.Text:='1';
    DF:=1;
  end;
  if DF>2000 then
  begin
    Edit1.Text:='2000';
    DF:=2000;
  end;
  Form4.Visible:=false;
  Form5.Visible:=false;
end;


procedure TForm1.Edit3Change(Sender: TObject);
begin
  Edit4.Text:='';
end;


procedure TForm1.Edit3Exit(Sender: TObject);
begin
  Form4.Visible:=false;
end;

procedure TForm1.Edit5Change(Sender: TObject);
begin
  Edit6.Text:='';
end;


procedure TForm1.Edit5Exit(Sender: TObject);
var AuxVar : real;
begin
  Auxvar:=stringtofloat(Edit5.Text);
  Edit5.Text:=format('%4.2f',[AuxVar]);
  Form4.Visible:=false;
end;



procedure TForm1.LabeledEdit7Change(Sender: TObject);
begin
  LabeledEdit8.Text:='';
  Button7.Enabled:=false;
end;


procedure TForm1.LabeledEdit9Change(Sender: TObject);
begin
  LabeledEdit8.Text:='';
  Button7.Enabled:=false;
end;


procedure TForm1.Button1Click(Sender: TObject);
var Prob, Teta, HlpVar, Factor1, Factor2, Sum : real;  ii : integer;
begin

  DF:=strtoint(Edit1.text);
  if DF>300 then DF:=300;
  Ttest:=stringtofloat(Edit3.text);
  Negative:=false;
  if Ttest<0 then
  begin
    Ttest:=-Ttest;
    Negative:=true;
  end;
  Form4.Visible:=false;
  CalcProb:=true;

  Teta:=arctan(Ttest/sqrt(DF));
  if frac(DF/2)=0 then
  begin
    Sum:=1+sqr(cos(teta))/2;
    ii:=1;
    Factor1:=1;
    Factor2:=2;
    while ii < DF-3  do
    begin
      ii:=ii+2;
      Factor1:=ii*Factor1;
      Factor2:=(ii+1)*Factor2;
      HlpVar:=(ii+1)*ln(cos(Teta));
      HlpVar:=exp(HlpVar);
      Sum:=Sum+Factor1*HlpVar/Factor2;
    end;
    if DF=2 then Sum:=Sum-sqr(cos(teta))/2;
    Prob:=sin(Teta)*Sum;
  end else
  begin
    if DF=1 then Prob:=2*Teta/pi
    else
    begin
      ii:=0;
      Factor1:=1;
      Factor2:=1;
      Sum:=1;
      while ii < DF-3 do
      begin
        ii:=ii+2;
        Factor1:=ii*Factor1;
        Factor2:=(ii+1)*Factor2;
        HlpVar:=ii*ln(cos(Teta));
        HlpVar:=exp(HlpVar);
        Sum:=Sum+Factor1*HlpVar/Factor2;
      end;
      Prob:=2*Teta/pi+(2/pi)*cos(Teta)*sin(Teta)*Sum;
    end;
  end;

  if Negative then Prob:=0.5*(1-Prob)
  else Prob:=Prob+0.5*(1-Prob);
  Button3.Enabled:=true;
  Edit4.Text:=format('%4.1f',[100*Prob]);

end; {Button1Click}


procedure TForm1.Button2Click(Sender: TObject);
label 1;
var ii, jj : integer; Teta, Sum, Factor1, Factor2, HlpVar, Prob, Proba : real;
begin
  Form4.Visible:=false;
  DF:=strtoint(Edit1.text);
  Probab:=stringtofloat(Edit5.text);
  Proba:=Probab/100;
  if Proba>0.5 then Probab:=Proba-(1-Proba)
  else Probab:=1-2*Proba;

  if DF<=0 then
  begin
    showmessage ('Make sure that DF-numerator is > 0');
    exit;
  end;

  Ttest:=0;
  for jj:=1 to 500000 do
  begin
    Ttest:=Ttest+jj*0.00001;
    Teta:=arctan(Ttest/sqrt(DF));
    if frac(DF/2)=0 then
    begin
      Sum:=1+sqr(cos(teta))/2;
      ii:=1;
      Factor1:=1;
      Factor2:=2;
      while ii < DF-3  do
      begin
        ii:=ii+2;
        Factor1:=ii*Factor1;
        Factor2:=(ii+1)*Factor2;
        HlpVar:=(ii+1)*ln(cos(Teta));
        HlpVar:=exp(HlpVar);
        Sum:=Sum+Factor1*HlpVar/Factor2;
      end;
      if DF=2 then Sum:=Sum-sqr(cos(teta))/2;
      Prob:=sin(Teta)*Sum;
      end else
      begin
        if DF=1 then Prob:=2*Teta/pi
        else
        begin
          ii:=0;
          Factor1:=1;
          Factor2:=1;
          Sum:=1;
          while ii < DF-3 do
          begin
            ii:=ii+2;
            Factor1:=ii*Factor1;
            Factor2:=(ii+1)*Factor2;
            HlpVar:=ii*ln(cos(Teta));
            HlpVar:=exp(HlpVar);
            Sum:=Sum+Factor1*HlpVar/Factor2;
          end;
          Prob:=2*Teta/pi+(2/pi)*cos(Teta)*sin(Teta)*Sum;
        end;
      end;
    if Prob>Probab then goto 1;
  end; {for jj:=1 to 50000 do}

1:if Proba<0.50 then Ttest:=-Ttest;
  Edit6.Text:=format('%4.2f',[Ttest]);
  Button4.Enabled:=true;
end; {Button2Click}



procedure TForm1.Button3Click(Sender: TObject);
begin
  Edit6.Text:='';
  Button4.Enabled:=false;
  MakeProbs;
  CalcProb:=true;
  MakeProbGraph;
  Form4.Show;
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  Edit4.Text:='';
  Button3.Enabled:=false;
  MakeProbs;
  CalcProb:=false;
  MakeProbGraph;
  Form4.show;
end;



procedure TForm1.Button5Click(Sender: TObject);
var Prob, Teta, HlpVar, Sum   : real;
    Ttest, Prob1, Prob2 : real;
    Factor1, Factor2    : extended;
    ii : longint;

begin
  Try LowerPoint := StringToFloat (LabeledEdit7.Text);
      Except on E: Exception do
      begin
        Showmessage ('The value of L is not a valid real');
        DecimalSeparator := InitDecSep;
        exit;
      end;
   end;
  Try UpperPoint := StringToFloat (LabeledEdit9.Text);
      Except on E: Exception do
      begin
        Showmessage ('The value of U is not a valid real');
        DecimalSeparator := InitDecSep;
        exit;
      end;
  end;
  if (LowerPoint<-4) or (LowerPoint>4) then
  begin
    showmessage ('The value of L must be > -4 and < +4)');
    LabeledEdit7.Text:='';
    exit;
  end;
  if (UpperPoint<-4) or (UpperPoint>4) then
  begin
    showmessage ('The value of U must be > -4 and < +4)');
    LabeledEdit9.Text:='';
    exit;
  end;
  if (LowerPoint>=UpperPoint) then
  begin
    showmessage ('The value of L must be smaller than the value of U)');
    LabeledEdit7.Text:='';
    LabeledEdit9.Text:='';
    exit;
  end;
  DF:=strtoint(Edit1.text);

  Ttest:=LowerPoint;
  Negative:=false;
  if Ttest<0 then
  begin
    Ttest:=-Ttest;
    Negative:=true;
  end;
  Form4.Visible:=false;
  Teta:=arctan(Ttest/sqrt(DF));
  if frac(DF/2)=0 then
  begin
    Sum:=1+sqr(cos(teta))/2;
    ii:=1;
    Factor1:=1;
    Factor2:=2;
    while ii < DF-3  do
    begin
      ii:=ii+2;
      Factor1:=ii*Factor1;
      Factor2:=(ii+1)*Factor2;
      HlpVar:=(ii+1)*ln(cos(Teta));
      HlpVar:=exp(HlpVar);
      Sum:=Sum+Factor1*HlpVar/Factor2;
    end;
    if DF=2 then Sum:=Sum-sqr(cos(teta))/2;
    Prob:=sin(Teta)*Sum;
  end else
  begin
    if DF=1 then Prob:=2*Teta/DF
    else
    begin
      ii:=0;
      Factor1:=1;
      Factor2:=1;
      Sum:=1;
      while ii < DF-3 do
      begin
        ii:=ii+2;
        Factor1:=ii*Factor1;
        Factor2:=(ii+1)*Factor2;
        HlpVar:=ii*ln(cos(Teta));
        HlpVar:=exp(HlpVar);
        Sum:=Sum+Factor1*HlpVar/Factor2;
      end;
      Prob:=2*Teta/pi+(2/pi)*cos(Teta)*sin(Teta)*Sum;
    end;
  end;

  if Negative then Prob1:=0.5*(1-Prob)*100
  else Prob1:=100*(1+0.5*(Prob-1));

  Ttest:=UpperPoint;
  Negative:=false;
  if Ttest<0 then
  begin
    Ttest:=-Ttest;
    Negative:=true;
  end;
  Form4.Visible:=false;
  Teta:=arctan(Ttest/sqrt(DF));
  if frac(DF/2)=0 then
  begin
    Sum:=1+sqr(cos(teta))/2;
    ii:=1;
    Factor1:=1;
    Factor2:=2;
    while ii < DF-3  do
    begin
      ii:=ii+2;
      Factor1:=ii*Factor1;
      Factor2:=(ii+1)*Factor2;
      HlpVar:=(ii+1)*ln(cos(Teta));
      HlpVar:=exp(HlpVar);
      Sum:=Sum+Factor1*HlpVar/Factor2;
    end;
    if DF=2 then Sum:=Sum-sqr(cos(teta))/2;
    Prob:=sin(Teta)*Sum;
  end else
  begin
    if DF=1 then Prob:=2*Teta/DF
    else
    begin
      ii:=0;
      Factor1:=1;
      Factor2:=1;
      Sum:=1;
      while ii < DF-3 do
      begin
        ii:=ii+2;
        Factor1:=ii*Factor1;
        Factor2:=(ii+1)*Factor2;
        HlpVar:=ii*ln(cos(Teta));
        HlpVar:=exp(HlpVar);
        Sum:=Sum+Factor1*HlpVar/Factor2;
      end;
      Prob:=2*Teta/pi+(2/pi)*cos(Teta)*sin(Teta)*Sum;
    end;
  end;

  if Negative then Prob2:=0.5*(1-Prob)*100
  else Prob2:=100*(1+0.5*(Prob-1));

  Prob:=(Prob2-Prob1);
  LabeledEdit8.Text:=format('%4.1f',[Prob]);
  Button7.Enabled:=true;

end; {TForm1.Button5Click}


procedure TForm1.Button7Click(Sender: TObject);
{---------------------------------------------}
begin
  MakeProbs;
  MakeIntervGraph;
end; {TForm1.Button7Click}
{------------------------}


procedure TForm1.MakeProbs;
{-------------------------}
var Teta, HlpVar, Factor1, Factor2, Sum, Prob : real;
    TmpValue : array [1..1000] of real;
    ii, kk : integer;
begin

  DF:=strtoint(Edit1.text);
  if DF>300 then DF:=300;
  Ttest:=0;
  for kk:=1 to 999 do
  begin
    Ttest:=kk*0.004;
    Teta:=arctan(Ttest/sqrt(DF));
    if frac(DF/2)=0 then
    begin
      Sum:=1+sqr(cos(teta))/2;
      ii:=1;
      Factor1:=1;
      Factor2:=2;
      while ii < DF-3  do
      begin
        ii:=ii+2;
        Factor1:=ii*Factor1;
        Factor2:=(ii+1)*Factor2;
        HlpVar:=(ii+1)*ln(cos(Teta));
        HlpVar:=exp(HlpVar);
        Sum:=Sum+Factor1*HlpVar/Factor2;
      end;
      if DF=2 then Sum:=Sum-sqr(cos(teta))/2;
      Prob:=sin(Teta)*Sum;
      Fvalue[kk]:=-4+8*kk*0.001;
      TmpValue[kk]:=Prob;
    end else
    begin
      if DF=1 then
      begin
        Probability[kk]:=2*Teta/pi;
        Fvalue[kk]:=-4+8*kk*0.001;
        TmpValue[kk]:=Probability[kk];
      end else
      begin
        ii:=0;
        Factor1:=1;
        Factor2:=1;
        Sum:=1;
        while ii < DF-3 do
        begin
          ii:=ii+2;
          Factor1:=ii*Factor1;
          Factor2:=(ii+1)*Factor2;
          HlpVar:=ii*ln(cos(Teta));
          HlpVar:=exp(HlpVar);
          Sum:=Sum+Factor1*HlpVar/Factor2;
        end;
        Prob:=2*Teta/pi+(2/pi)*cos(Teta)*sin(Teta)*Sum;
        Fvalue[kk]:=-4+8*kk*0.001;
        TmpValue[kk]:=Prob;
      end;
    end;
  end; {for kk:=1 to 999 do}

  for kk:=1 to 999 do
  begin
    if kk<500 then
       Probability[kk]:=0.5*(1-Tmpvalue[1000-2*kk])
    else
       Probability[kk]:=0.5+0.5*(TmpValue[2*(kk-499)-1]);
  end;

  for kk:=2 to 999 do Density[kk]:=(Probability[kk]-Probability[kk-1])/8;
  Density[1]:=Density[2];
  Density[500]:=Density[499];
  for kk:=1 to 999 do Density[kk]:=141000*Density[kk];
  
end;
{end of MakeProbs}
{----------------}



procedure TForm1.MakeProbGraph;
{-----------------------------}
var DumReal : real; NameStr : string;
    ii : integer;
    XdataRel,YdataRel        : real;
    Xmax, AuxVar             : real;
    MinX, MinY, MaxX, MaxY   : integer;
    ScaleX, ScaleY, LX, LY   : integer;
    DecimX, DecimY           : integer;
    RelXdata, RelYdata       : integer;
    XrTxt : string;
    myRect : TRect;
begin
  Xmax:=Fvalue[990];
  if Xmax>20 then Xmax:=20;
  MinX:=round(Fvalue[1]);
  MaxX:=round(Xmax);
  MinY:=0;
  MaxY:=1;
  ScaleX:=8;
  ScaleY:=10;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimX:=1;
  if Xmax<1 then DecimX:=2;
  DecimY:=1;

  With Form4.Image1.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form4.Image1.Canvas.ClipRect);
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,481,321);
    FillRect (myRect);
    Textout (30,3,'t - Test values and  cumulative probability');
    Font.Size := 8;
    TextOut (20,304,'t-Test calculator at www.waterlog.info/t-tester.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,460,300);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    XrTxt:='Degrees of freedom = '+Edit1.text;
    TextOut (PosX1-40,25,XrTxt);
    Textout (388,284,'t-test value');
    TextOut (PosX1-3,52,'Cumulative probability');
    if CalcProb then XrTxt:='t-value = '+Edit3.Text
    else XrTxt:='t-value = '+Edit6.Text;
    TextOut (263,25,XrTxt);
    if CalcProb then XrTxt := Edit4.Text
    else XrTxt := Edit5.Text;
    AuxVar:= strtofloat(XrTxt);
    AuxVar:=AuxVar/100;
    XrTxt := format('%5.2f',[AuxVar]);
    Pen.Color := clRed;
    XrTxt:='cumulative probability = '+XrTxt;
    TextOut (200,40,XrTxt);
    Pen.Color := clWhite;

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    for ii:=1 to 998 do
    begin
      XdataRel := LX * (Fvalue[ii] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Probability[ii]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      if Fvalue[ii]<20 then moveto (RelXdata,RelYdata);

      XdataRel := LX * (Fvalue[ii+1] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Probability[ii+1]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      if Fvalue[ii]<20 then lineto (RelXdata,RelYdata);

    end;
    if CalcProb then AuxVar := StringToFloat (Edit3.Text)
    else AuxVar := StringToFloat (Edit6.Text);
    XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
    RelXdata := PosX1+round(XdataRel);
    if CalcProb then AuxVar := StringToFloat (Edit4.Text)
    else AuxVar := StringToFloat (Edit5.Text);
    YdataRel := LY*(AuxVar/100-MinY)/(MaxY-MinY);
    RelYdata := PosY2-round(YdataRel);

    Pen.Color:=clRed;
    Pen.Style := psDot;
    if AuxVar/100<0.2 then Pen.Style := psSolid;;
    if AuxVar/100<0.1 then Pen.Width:=2;
    moveto (RelXdata,PosY2);
    lineto (RelXdata,RelYdata);
    Pen.Color:=clWhite;
    Pen.Style := psSolid;
    Pen.Width:=1;

  end; {with Form4.Image.canvas do}
end; {MakeProbGraph}


procedure TForm1.MakeIntervGraph;
{-------------------------------}
var DumReal : real; NameStr : string;
    ii : integer;
    XdataRel,YdataRel, Factor : real;
    Xmin, Xmax, Step, AuxVar : real;
    MinX, MinY, MaxX, MaxY : integer;
    ScaleX, ScaleY, LX, LY : integer;
    DecimX, DecimY : integer;
    RelXdata1, RelYdata1 : integer;
    RelXdata2, RelYdata2 : integer;
    FrqTxt, XrTxt : string;
    myRect : TRect;
begin

  Factor:=1;
  LowerLimit:=-4;
  UpperLimit:=4;
  DumReal:=stringtofloat (LabeledEdit7.Text);
  LowerPoint:=DumReal;
  DumReal:=stringtofloat (LabeledEdit9.Text);
  UpperPoint:=DumReal;
  Xmin:=LowerLimit;
  MinX:=round(Xmin);
  Xmax:=UpperLimit;
  MaxX:=round(Xmax);
  MinY:=0;
  MaxY:=70;
  ScaleX:=8;
  ScaleY:=7;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimX:=1;
  if Xmin<1 then DecimX:=2;
  DecimY:=2;
  UpperLimit:=Factor*UpperLimit;
  LowerLimit:=Factor*LowerLimit;
  Step:=(UpperLimit-LowerLimit)/800;

  With Form5.Image1.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form5.Image1.Canvas.ClipRect);
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,481,321);
    FillRect (myRect);
    Textout (30,3,'Calculated interval probability P(L<X<U) for given'+
                       ' L and U values');
    Font.Size := 8;
    TextOut (20,304,'t-Tester program at www.waterlog.info/t-tester.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,460,300);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    XrTxt:='Degrees of freedom = '+Edit1.text;
    TextOut (PosX1-40,25,XrTxt);
    Textout (387,285,'t-test value');
    TextOut (PosX1,50,'probability density');
    XrTxt:='Lower limit of X:  L = '+LabeledEdit7.Text;
    TextOut (PosX1+200,35,XrTxt);
    XrTxt:='Upper  limit of X:  U = '+LabeledEdit9.Text;
    TextOut (PosX1+200,50,XrTxt);
    AuxVar:=stringtofloat (LabeledEdit8.Text)/100;
    XrTxt := format('%5.3f',[AuxVar]);
    FrqTxt:='Interval probability = green area = '+XrTxt;
    TextOut (PosX1+138,65,FrqTxt);

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY/100 - DumReal/100]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)/Factor]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    if LowerPoint<LowerLimit then LowerPoint:=LowerLimit;

    for ii:= 1 to 799 do
    begin

      AuxVar := LowerLimit+Step*ii;
      XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
      RelXdata1 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii+100]-MinY)/(MaxY-MinY);
      RelYdata1 := PosY2-round(YdataRel);

      XdataRel := LX * (LowerLimit+Step*(ii+1) - MinX) /(MaxX-MinX);
      RelXdata2 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii+1+100]-MinY)/(MaxY-MinY);
      RelYdata2 := PosY2-round(YdataRel);

      if (AuxVar>LowerPoint) and (AuxVar<Upperpoint) then
      begin
        Brush.Color := clTeal;
        Fillrect (Rect(RelXdata1,RelYData1,RelXdata2,PosY2));
      end;

      moveto (RelXdata1,RelYdata1);
      lineto (RelXdata2,RelYdata2);

    end;

//horizontal line at maximim density
      AuxVar := LowerLimit;
      XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
      RelXdata1 := PosX1+round(XdataRel);
      AuxVar := 0;
      XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
      RelXdata2 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[500]-MinY)/(MaxY-MinY);
      RelYdata1 := PosY2-round(YdataRel);
      Pen.Style := psDot;
      Brush.Color := clblue;
      moveto (RelXdata1,RelYdata1);
      lineto (RelXdata2,RelYdata1);
      XrTxt := format('%4.2f',[Density[500]/100]);
      TextOut((RelXdata1+RelXdata2) div 2 - 30, RelYdata1-15,XrTxt);
      Brush.Color := clblue;

  end; {with CumGraphImage.canvas}
  Form5.Visible:=true;

end; {procedure TForm1.MakeIntervGraph}
{-------------------------------------}


function TForm1.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator := OldDecSep;
    end;
  end;
end; {TForm1.StringToFloat}



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caNone;
     Form2.Show;
end; {TMainForm.FormClose}


end.
